###############################
# Makefile for SMBUTIL        #
# For use with Borland C++    #
# Tabstop=8		      #
###############################

# ATTN: To use this MAKEFILE, you must create a directory "l" off of the
#       current directory to store the large model .OBJ files

# Macros
CC	= bcc
LD	= tlink
INCLUDE = \bc\include
LIB	= \bc\lib
MODEL	= l
CFLAGS	= -d -C -m$(MODEL) -I$(INCLUDE)
LFLAGS	= -n -c
MAIN	= smbutil.exe
OBJS	= $(MODEL)\smbutil.obj $(MODEL)\smblib.obj $(MODEL)\smbvars.obj
HEADERS = smbutil.h smblib.h smbdefs.h crc32.h

# Implicit C Compile Rule
{.}.c.obj:
	@echo Compiling (I) $< to $@ ...
	$(CC) $(CFLAGS) -n$(MODEL) -c $<

# Main EXE Link Rule
$(MAIN): $(OBJS)
    	@echo Linking $< ...
	$(LD) $(LFLAGS) @&&+
$(LIB)\c0$(MODEL) $(OBJS) $(LIB)\wildargs.obj
+ $*, $*, $(LIB)\c$(MODEL).lib $(LIB)\math$(MODEL).lib $(LIB)\emu.lib

# All .obj modules
$(MODEL)\smbutil.obj:	$(HEADERS)
$(MODEL)\smbvars.obj:	$(HEADERS)
$(MODEL)\smblib.obj:	$(HEADERS)
